import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function intersection() {
    return purry(_intersection, arguments, intersection.lazy);
}
function _intersection(array, other) {
    var lazy = intersection.lazy(other);
    return _reduceLazy(array, lazy);
}
(function (intersection) {
    function lazy(other) {
        var set = new Set(other);
        return function (value) {
            return set.has(value)
                ? { done: false, hasNext: true, next: value }
                : { done: false, hasNext: false };
        };
    }
    intersection.lazy = lazy;
})(intersection || (intersection = {}));
